// sampleDlg.cpp : t@C
//

#include "stdafx.h"
#include "sample.h"
#include "sampleDlg.h"
#include "bvcm.h"

UINT guiInterfaceNumber;
BVCM_HANDLE gbhBvcmHandle;
BVCM_STATUS gbsBvcmStatus;
bool gbExistsBV;
bool gbExistsCM;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CsampleDlg _CAO

CsampleDlg::CsampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CsampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_Font.CreatePointFont(90,"lr SVbN");
}

void CsampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CsampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CsampleDlg bZ[W nh

BOOL CsampleDlg::OnInitDialog()
{
	char buf[300];

	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	GetDlgItem(IDC_STATIC1)->SetFont(&m_Font);
	GetDlgItem(IDC_STATIC2)->SetFont(&m_Font);

	m_BvEnable = false;
	m_CmEnable = false;

	gbsBvcmStatus = BVCM_ScanInterface(&guiInterfaceNumber);
	if(guiInterfaceNumber != 0)
	{
		gbsBvcmStatus = BVCM_OpenInterface(0, &gbhBvcmHandle);
		if(gbsBvcmStatus == BVCM_OK) 
		{
			gbsBvcmStatus = BVCM_Standby(gbhBvcmHandle, BVCM_COIN);
			if(gbsBvcmStatus == BVCM_ACK1) gbExistsCM = true;
			else gbExistsCM = false;

			gbsBvcmStatus = BVCM_Standby(gbhBvcmHandle, BVCM_BILL);
			if(gbsBvcmStatus == BVCM_ACK1) gbExistsBV = true;
			else gbExistsBV = false;
		}
	}

	if(gbExistsCM == true)
	{
		gbsBvcmStatus = BVCM_GetAllData(gbhBvcmHandle, BVCM_COIN, buf, sizeof buf);
		if(gbsBvcmStatus == BVCM_ACK1) ParseBvcmData2(BVCM_COIN, buf + 1);
	}

	if(gbExistsBV == true)
	{
		gbsBvcmStatus = BVCM_GetAllData(gbhBvcmHandle, BVCM_BILL, buf, sizeof buf);
		if(gbsBvcmStatus == BVCM_ACK1) ParseBvcmData2(BVCM_BILL, buf + 1);
	}

	SetTimer(1, 800, NULL);
	
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CsampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CsampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CsampleDlg::OnTimer(UINT nIDEvent)
{
	char buf[300];

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(gbExistsCM == true)
	{
		gbsBvcmStatus = BVCM_GetData(gbhBvcmHandle, BVCM_COIN, buf, sizeof buf);
		if(gbsBvcmStatus == BVCM_ACK2) ParseBvcmData1(BVCM_COIN, buf + 1);
		else if(gbsBvcmStatus == BVCM_ACK3) ParseBvcmData2(BVCM_COIN, buf + 1);
	}

	if(gbExistsBV == true)
	{
		gbsBvcmStatus = BVCM_GetData(gbhBvcmHandle, BVCM_BILL, buf, sizeof buf);
		if(gbsBvcmStatus == BVCM_ACK2) ParseBvcmData1(BVCM_BILL, buf + 1);
		else if(gbsBvcmStatus == BVCM_ACK3) ParseBvcmData2(BVCM_BILL, buf + 1);
	}

	DispInt2Control(IDC_EDIT1, m_Cash.i10Y);
	DispInt2Control(IDC_EDIT2, m_Cash.i50Y);
	DispInt2Control(IDC_EDIT3, m_Cash.i100Y);
	DispInt2Control(IDC_EDIT4, m_Cash.i500Y);
	DispInt2Control(IDC_EDIT5, m_Cash.i1000Y);

	CDialog::OnTimer(nIDEvent);
}

void CsampleDlg::OnBnClickedButton1()
{
	char buf[5];
	char tmp;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if(m_BvEnable == false)
	{
		buf[0] = 3;					// bytes
		tmp = buf[0];
		buf[1] = 0x10;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x31;				// data1
		tmp = tmp ^ buf[2];
		buf[3] = 0x00;				// data2
		tmp = tmp ^ buf[3];
		buf[4] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_BILL, buf);
		if(gbsBvcmStatus == BVCM_ACK1)
		{
			m_BvEnable = true;
			DispStr2Control(IDC_BUTTON1, "~");
			GetDlgItem(IDC_BUTTON2)->EnableWindow(false);
			GetDlgItem(IDC_BUTTON3)->EnableWindow(false);
		}
	}
	else
	{
		buf[0] = 3;					// bytes
		tmp = buf[0];
		buf[1] = 0x10;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x30;				// data1
		tmp = tmp ^ buf[2];
		buf[3] = 0x00;				// data2
		tmp = tmp ^ buf[3];
		buf[4] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_BILL, buf);
		if(gbsBvcmStatus == BVCM_ACK1)
		{
			m_BvEnable = false;
			DispStr2Control(IDC_BUTTON1, "Jn");
			GetDlgItem(IDC_BUTTON2)->EnableWindow(true);
			GetDlgItem(IDC_BUTTON3)->EnableWindow(true);
		}
	}
}

void CsampleDlg::OnBnClickedButton2()
{
	char buf[7];
	char tmp;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	buf[0] = 5;						// bytes
	tmp = buf[0];
	buf[1] = 0x11;					// data command
	tmp = tmp ^ buf[1];
	buf[2] = 0;
	tmp = tmp ^ buf[2];
	buf[3] = IntToBcd(m_Cash.i1000Y) << 4;
	tmp = tmp ^ buf[3];
	buf[4] = 0;
	tmp = tmp ^ buf[4];
	buf[5] = 0;
	tmp = tmp ^ buf[5];
	buf[6] = tmp;					// fcc
	gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_BILL, buf);
	if(gbsBvcmStatus = BVCM_ACK1)
	{
		buf[0] = 3;					// bytes
		tmp = buf[0];
		buf[1] = 0x10;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x32;				// }NA
		tmp = tmp ^ buf[2];
		buf[3] = 0;
		tmp = tmp ^ buf[3];
		buf[4] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_BILL, buf);
	}
}

void CsampleDlg::OnBnClickedButton3()
{
	char buf[7];
	char tmp;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	buf[0] = 3;						// bytes
	tmp = buf[0];
	buf[1] = 0x10;					// data command
	tmp = tmp ^ buf[1];
	buf[2] = 0x32;					// 
	tmp = tmp ^ buf[2];
	buf[3] = 0;
	tmp = tmp ^ buf[3];
	buf[4] = tmp;					// fcc
	gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_BILL, buf);
}

void CsampleDlg::OnBnClickedButton4()
{
	char buf[4];
	char tmp;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if(m_CmEnable == false)
	{
		buf[0] = 2;					// bytes
		tmp = buf[0];
		buf[1] = 0x00;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x01;				// data
		tmp = tmp ^ buf[2];
		buf[3] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_COIN, buf);
		if(gbsBvcmStatus == BVCM_ACK1)
		{
			m_CmEnable = true;
			DispStr2Control(IDC_BUTTON4, "~");
			GetDlgItem(IDC_BUTTON5)->EnableWindow(false);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(false);
		}
	}
	else
	{
		buf[0] = 2;					// bytes
		tmp = buf[0];
		buf[1] = 0x00;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x00;				// data
		tmp = tmp ^ buf[2];
		buf[3] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_COIN, buf);
		if(gbsBvcmStatus == BVCM_ACK1)
		{
			m_CmEnable = false;
			DispStr2Control(IDC_BUTTON4, "Jn");
			GetDlgItem(IDC_BUTTON5)->EnableWindow(true);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(true);
		}
	}
}

void CsampleDlg::OnBnClickedButton5()
{
	char buf[6];
	char tmp;
	int cash, d10, d100, d1000, d10000;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	buf[0] = 4;						// bytes
	tmp = buf[0];
	buf[1] = 0x01;					// data command
	tmp = tmp ^ buf[1];
	cash = (m_Cash.i500Y * 500)
		 + (m_Cash.i100Y * 100)
		 + (m_Cash.i50Y * 50)
		 + (m_Cash.i10Y * 10);
	d10000 = cash / 10000;
	d1000 = (cash % 10000) / 1000;
	d100 = (cash - (d10000 * 10000) - (d1000 * 1000)) / 100;
	d10 = (cash - (d10000 * 10000) - (d1000 * 1000) - (d100 * 100)) / 10;
	buf[2] = d10 << 4;
	tmp = tmp ^ buf[2];
	buf[3] = (d1000 << 4) + d100;
	tmp = tmp ^ buf[3];
	buf[4] = d10000;
	tmp = tmp ^ buf[4];
	buf[5] = tmp;					// fcc
	gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_COIN, buf);
	if(gbsBvcmStatus = BVCM_ACK1)
	{
		buf[0] = 2;					// bytes
		tmp = buf[0];
		buf[1] = 0x00;				// data command
		tmp = tmp ^ buf[1];
		buf[2] = 0x02;				// }NA
		tmp = tmp ^ buf[2];
		buf[3] = tmp;				// fcc
		gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_COIN, buf);
	}
}

void CsampleDlg::OnBnClickedButton6()
{
	char buf[6];
	char tmp;

	// TODO : ɃRg[ʒmnh R[hǉ܂B
	buf[0] = 2;						// bytes
	tmp = buf[0];
	buf[1] = 0x00;					// data command
	tmp = tmp ^ buf[1];
	buf[2] = 0x02;					// 
	tmp = tmp ^ buf[2];
	buf[3] = tmp;					// fcc
	gbsBvcmStatus = BVCM_PutData(gbhBvcmHandle, BVCM_COIN, buf);
}

void CsampleDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO : ɃbZ[W nh R[hǉ܂B
	m_Font.DeleteObject();
}
